"use strict";

jQuery(document).ready(function ($) {
  var marker, map, infobox;

  if (jQuery("#cma-wrapper").length && !jQuery("#cma-wrapper").parents('div[data-elementor-type="popup"]').length) {
    init();
  } else {
    //Support for Elementor popups
    window.addEventListener('elementor/popup/show', function () {
      var popupelement = jQuery('div[data-elementor-type="popup"]').find("#cma-wrapper");

      if (popupelement.length) {
        init();
      }
    });
  }

  function init() {
    init_popup_message();
    init_address_input();
    extras();

    if (cmadel.pick_from_map != 'no' || cmadel.szbd_active == 1) {
      preinitMap();
    }
  }

  function extras() {
    $(document).on('input', '#autocomplete_cma', function () {
      $(this).aropopover('hide');
      $(this).removeClass('cma-fail').removeClass('cma-success');

      if (document.getElementById('cma_address_fractions') !== null) {
        document.getElementById('cma_address_fractions').reset();
      }

      $('#cma_delivery_notice_outer, #cma_delivery_notice_wrapper').removeClass('cma-fail').removeClass('cma-success').find('#cma_delivery_notice').fadeOut('slow').remove();
    });
    jQuery(document).off('hidden.bs.aromodal').on('hidden.bs.aromodal', '#cma_precise_streetnumber', function () {
      try {
        jQuery('.cma-confirm-marker').off('.cma-map');
        jQuery('.cma-confirm-marker').removeClass('cma-conform-marker-checkout');
        marker.setMap(null);
        marker = null;
      } catch (error) {}
    });
  }

  function init_popup_message() {
    cma_default_popover_message();
    var pop_timeout;

    if (typeof pop_timeout !== "undefined") {
      clearTimeout(pop_timeout);
    }

    $('#cma-pop-min').off('show.bs.aropopover.change').on('show.bs.aropopover.change', function () {
      if (typeof pop_timeout !== "undefined") {
        clearTimeout(pop_timeout);
      }

      pop_timeout = setTimeout(function () {
        $('#cma-pop-min').aropopover('hide');
      }, 8000);
    });
    $('#cma-pop-min').off('hidden.bs.aropopover.change').on('hidden.bs.aropopover.change', function () {
      if (typeof pop_timeout !== "undefined") {
        clearTimeout(pop_timeout);
      }

      reset_popover_message();
    }); //Hide when click input form

    $('#autocomplete_cma').on('click', function (e) {
      $('#cma-pop-min').aropopover('hide');
      jQuery(e.currentTarget).attr("placeholder", cmadel.geolocation_placeholder);
    });
  }

  function cma_default_popover_message() {
    var content;
    content = '<span class="cma_popover_message">' + cmadel.top_bar_info + '</span>';
    $('#cma-pop-min[data-toggle="aropopover"]').aropopover({
      'template': '<div class="aropopover" role="tooltip"><div class="arrow"></div><div class="aropopover-content"></div></div>',
      'content': content,
      //'placement': 'auto top',
      'trigger': 'hover',
      'placement': function placement(context, source) {
        var isMobile = window.matchMedia("only screen and (max-width: 767px)").matches;

        if (isMobile) {
          return "left auto";
        }

        var position = $(source).position();

        if (typeof position === 'undefined') {
          return 'top';
        }

        if (position.top === 0) {
          return "auto";
        }

        if (position.top < 110) {
          return "bottom";
        }

        return "auto";
      }
    });
    $('#cma_adress_row #autocomplete_cma').aropopover({
      'template': '<div class="aropopover" role="tooltip"><div class="arrow"></div><div class="aropopover-content"></div></div>',
      'html': true,
      'trigger': 'manual',
      'content': "<span id='cma_delivery_notice77'>" + cmadel.del_message_5 + "</span>",
      'placement': 'bottom',
      'toggle': 'aropopover',
      'container': '.del_address_row'
    });
  }

  function reset_popover_message() {
    content = '<span class="cma_popover_message">' + cmadel.top_bar_info + '</span>';
    var popover_ = $('#cma-pop-min').attr('data-content', content).data('bs.aropopover');
    popover_.setContent();
    popover_.$tip.addClass(popover_.options.placement);
    popover_.$tip.removeClass('failure').removeClass('success');
  }

  function print_pickup_message_standard() {
    $('#cma-pop-min').aropopover('hide');
  }

  function show_popover(popObject, popover, displayClass) {
    if (typeof popover !== 'undefined') {
      popover.setContent();
      popover.$tip.addClass(popover.options.placement);

      if (cmadel.delivery_color == 1) {
        popover.$tip.removeClass('failure').removeClass('success').addClass(displayClass);
      }

      popObject.aropopover('show');
    }
  }

  function wait_for_map_location(validation_type) {
    outcome2 = $.Deferred();
    jQuery('.cma-confirm-marker').addClass('cma-conform-marker-checkout').off('click.cma-map').on('click.cma-map', function (e) {
      e.preventDefault();

      if (marker === undefined || marker === null) {
        return;
      }

      jQuery(this).removeClass('cma-conform-marker-checkout');
      var la = marker.getPosition().lat();
      var lo = marker.getPosition().lng();
      var evaluate = check_map_marker_position(marker.getPosition(), 'checkout', true);
      $.when(evaluate).then(function (evalu) {
        jQuery('#cma_precise_streetnumber').off('hidden.bs.aromodal.abort');
        $('#cma_precise_streetnumber').aromodal('hide');
        la = evalu === true ? la : null;
        lo = evalu === true ? lo : null;
        var response = validation_type == 'address' ? [evalu, la, lo] : evalu;
        outcome2.resolve(response);
      });
    });
    jQuery('#cma_precise_streetnumber').one('hidden.bs.aromodal.abort', function (e) {
      e.preventDefault();
      jQuery('.cma-confirm-marker').removeClass('cma-conform-marker-checkout');
      jQuery('#cma_precise_streetnumber').off('hidden.bs.aromodal.abort');
      var response = validation_type == 'address' ? [false, null, null] : false;
      outcome2.resolve(response);
    });
    return outcome2.promise();
  }

  function check_address_form(mode, current_location) {
    var theblock = jQuery('#cma_address_button');

    if ($.fn.blockUI != 'undefined') {
      theblock.addClass('processing').block({
        message: null,
        overlayCSS: {
          //background: '#fff',
          opacity: 0.7
        }
      });
    }

    var result = validate_address(theblock, mode, current_location);
    $.when(result).then(function (is_ok) {
      if (is_ok) {
        jQuery(document).trigger('cma_validation_ok');
      } else {
        jQuery(document).trigger('cma_validation_not_ok');
      }

      if ($.fn.blockUI != 'undefined') {
        theblock.removeClass('processing').unblock();
      }
    });
  }

  function init_address_input() {
    $(document).off('change.checkaddress').on('change.checkaddress', '#cma_saveaddress_checkbox', function () {
      var state = $(this).prop("checked");
      var data = {
        'action': 'cma_set_save_to_checkout',
        'save_state': state,
        'nonce_ajax': cmadel.nonce
      };
      $.post(cmadel.ajax_url, data, function () {});

      if (state == true) {
        $('#cma_address_button').trigger('click');
      }
    });
    $(document).on('cma_new_shipping_address', function () {
      jQuery('#autocomplete_cma').attr("placeholder", cmadel.geolocation_placeholder);
      check_address_form('initial', null);
    });
    $(document).off('click.checkaddress').on('click.checkaddress', '#cma_address_button', function (e) {
      $('.cma-text-feedback,.cma-form-feedback').find('#cma_delivery_notice').fadeTo('fast', '0.01', function () {
        $(this).parent().removeClass('cma-fail').removeClass('cma-success');
      });
      e.preventDefault();

      if ($('#autocomplete_cma').val().length === 0) {
        $('#autocomplete_cma').off('focus').on('focus', function () {
          print_message('address_not_valid', null, null);
          $('#autocomplete_cma').off('focus');
        });
        $('#autocomplete_cma').focus();
        return;
      }

      check_address_form('checkout', null);
    });
    $(document).off('click.cmageolocate').on('click.cmageolocate', '.cma-crosshair', function (e) {
      var target_ = jQuery(e.currentTarget).find('.cma-crosshair-icon');
      target_.addClass('fa-spin').fadeTo('slow', '0.5');
      $('.cma-text-feedback,.cma-form-feedback').find('#cma_delivery_notice').fadeTo('fast', '0.01', function () {
        $('#autocomplete_cma').removeClass('cma-fail').removeClass('cma-success');
        $('#cma_delivery_notice').parent().removeClass('cma-fail').removeClass('cma-success');
      });
      e.preventDefault();
      geolocate_action();
    });
    $(document).off('mousedown.cmageolocate_').on('mousedown.cmageolocate_', '#cma-geolocate-suggestion', function (e) {
      e.preventDefault();
      jQuery('.cma-crosshair').trigger('click');
      jQuery('#autocomplete_cma').trigger("focusout");
    });

    if (jQuery('.cma-crosshair').length) {
      $(document).one('click.cmageo', '#autocomplete_cma', function () {
        var el = jQuery('<div id="cma-geolocate-suggestion" class="pac-item">' + '<span class="cma-crosshair-drop"><i class="fas fa-crosshairs"></i> </span>' + cmadel.suggestiontext + '</div>');
        jQuery(".pac-container").prepend(el);
      });
    }
  }

  function geolocate_action() {
    if (navigator.geolocation) {
      var options = {
        enableHighAccuracy: true,
        timeout: 5000,
        maximumAge: 0
      };
      navigator.geolocation.getCurrentPosition(geoaction_ok, geoaction_fails, options);
    } else {
      var error = {};
      error.message = 'Navigator.geolocation is undefined';
      geoaction_fails(error);
    }
  }

  function geoaction_ok(position) {
    var pos = {
      lat: position.coords.latitude,
      lng: position.coords.longitude
    };

    if (position.coords.accuracy > cmadel.max_accuracy) {
      $('#cma_precise_streetnumber').aromodal('show');
      initMap(pos);
      var error = {};
      error.message = 'Too  low accuracy:' + position.coords.accuracy;
      geoaction_fails(error);
      return;
    }

    var geocoder = new google.maps.Geocoder();
    geocoder.geocode({
      location: pos
    }).then(function (response) {
      var accept_status = _.toArray(cmadel.result_types);

      var formatted_address = null;
      var geometry_location = null;

      _.each(response.results, function (element) {
        if (_.isNull(formatted_address) && _.intersection(element.types, accept_status).length) {
          if (typeof element.formatted_address !== 'undefined') {
            formatted_address = element.formatted_address;
            geometry_location = element.geometry.location;
          }
        }
      });

      var target_ = $('#cma_shipping_form').find('.cma-crosshair-icon');

      if (!_.isNull(formatted_address)) {
        jQuery('#autocomplete_cma').val('').attr("placeholder", cmadel.geolocation_placeholder); //alert([cmadel.geolocation_placeholder,'set placeholder']);

        jQuery('#autocomplete_cma').val(formatted_address);

        if (cmadel.validate_after_geolocation == 1 && !_.isNull(geometry_location)) {
          check_address_form('checkout', geometry_location);
        }

        target_.removeClass('fa-spin').fadeTo('slow', '1');
      } else {
        var _error = {};
        _error.message = 'Too  low accuracy:' + position.coords.accuracy;
        geoaction_fails(_error);
      }
    });
  }

  function geoaction_fails(err) {
    console.warn(err.message);
    var target_ = $('#cma_shipping_form').find('.cma-crosshair-icon');
    jQuery('#autocomplete_cma').val('').attr("placeholder", cmadel.geolocation_fail);
    target_.removeClass('fa-spin').fadeTo('slow', '1');
  }

  function validate_address(theblock, mode, current_location) {
    var outcome = $.Deferred();
    var addressPromise = cma_check_address(mode);
    $.when(addressPromise).then(function (valid_address) {
      if (valid_address[0] === false) {
        outcome.resolve(false);
      } else if (typeof valid_address[3] !== 'undefined') {
        outcome.resolve(valid_address[0]);
      } else {
        var latitude = valid_address[1];
        var longitude = valid_address[2];
        var cma_country = document.getElementById("cma_bshipping_country").value;
        var cma_postcode = document.getElementById("cma_bshipping_postcode").value;
        var cma_cma_adm1_long = document.getElementById("cma_adm1_long").value;
        var cma_cma_adm2_long = document.getElementById("cma_adm2_long").value;
        var cma_cma_adm1_short = document.getElementById("cma_adm1_short").value;
        var cma_cma_adm2_short = document.getElementById("cma_adm2_short").value;
        var cma_city = document.getElementById("cma_bshipping_city").value;
        var cma_address_1 = document.getElementById("cma_bshipping_address_1").value;
        var cma_address_full = document.getElementById("autocomplete_cma").value;
        var save_address = jQuery('#cma_saveaddress_checkbox').prop("checked") ? 1 : 0;
        var current_cart = jQuery('#cma-wrapper').hasClass("cma-current-cart") ? 1 : 0;
        var zone_id = jQuery('#cma-wrapper').hasClass("cma_zone_id") ? jQuery('#cma-wrapper').data('zone_id') : null;
        var data = {
          'action': 'cma_validate_shipping_address',
          'save_address': save_address,
          'country': cma_country,
          'postcode': cma_postcode,
          'cma_adm1_long': cma_cma_adm1_long,
          'cma_adm2_long': cma_cma_adm2_long,
          'cma_adm1_short': cma_cma_adm1_short,
          'cma_adm2_short': cma_cma_adm2_short,
          'city': cma_city,
          'address_1': cma_address_1,
          'full_address': cma_address_full,
          'current_cart': current_cart,
          'nonce_ajax': cmadel.nonce
        };

        if (zone_id != null) {
          data.zone_id = zone_id;
        }

        $.post(cmadel.ajax_url, data, function (response) {
          var validation_type = 'address';
          var evalu = evaluate_shipping_methods(response, latitude, longitude, validation_type, mode, false);
          $.when(evalu).then(function (evalue) {
            outcome.resolve(evalue);

            if (cmadel.is_checkout == 1 && evalue && $('#cma_saveaddress_checkbox').prop("checked")) {
              var location = !_.isNull(current_location) ? current_location : {
                lat: latitude,
                lng: longitude
              };
              update_checkout_shipping_form(location);
            }
          });
        }).always(function () {
          if ($.fn.blockUI != 'undefined') {
            theblock.removeClass('processing').unblock();
          }
        });
      }
    }).always(function () {});
    return outcome.promise();
  }

  function update_checkout_shipping_form(location) {
    if (cmadel.is_blocks_checkout == 1) {
      // Temporary solution to be compatible with blocks checkout and szbd
      // Outdated - Keep this for now to remain compatibility with SZBD
      $(window).trigger('cma_customer_address_is_set'); // More robust solution to be compatible with blocks checkout

      window.dispatchEvent(new CustomEvent("cma_customer_address_set", {
        bubbles: true
      }));
    } else {
      // This ajax request is for old checkout pages
      var data = {
        'action': 'cma_get_default_address',
        'nonce_ajax': cmadel.nonce
      };
      $.post(cmadel.ajax_url, data, function (response) {
        if ($('#ship-to-different-address').find('input').is(':checked')) {
          if ($('#shipping_state').is('select')) {
            $('#shipping_state').find('option').filter(function () {
              return $(this).val() == response.state;
            }).prop("selected", true).trigger('change.fdoe2');
          } else {
            $('#shipping_state').val(response.state);
          }

          $('#shipping_postcode').val(response.postcode);
          $('#shipping_city').val(response.city);
          $('#shipping_address_1').val(response.address_1);
          $('#shipping_address_2').val(response.address_2);
          $('#shipping_country').find('option').filter(function () {
            return $(this).val() == response.country;
          }).prop("selected", true).trigger('change');
        } else {
          if ($('#billing_state').is('select')) {
            $('#billing_state').find('option').filter(function () {
              return $(this).val() == response.state;
            }).prop("selected", true).trigger('change.fdoe2');
          } else {
            $('#billing_state').val(response.state);
          }

          $('#billing_postcode').val(response.postcode);
          $('#billing_city').val(response.city);
          $('input#billing_address_1').val(response.address_1);
          $('input#billing_address_2').val(response.address_2);
          $('#billing_country').find('option').filter(function () {
            return $(this).val() == response.country;
          }).prop("selected", true).trigger('change');
        }
      }).done(function () {
        if (jQuery('#szbd_map').is(":visible") && _.isObject(location)) {
          jQuery('#szbd_map').trigger('cma_placing_marker', [location]);
        } else {
          $(document.body).trigger('update_checkout');
        }
      });
    }
  }

  function insert_and_trigger(el_id) {
    var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var notToServer = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    try {
      value = value == false ? document.getElementById(el_id).value : value;
      var input = document.getElementById(el_id);
      input.value = value;
      var nativeInputValueSetter = Object.getOwnPropertyDescriptor(window.HTMLInputElement.prototype, 'value').set;
      nativeInputValueSetter.call(input, value);
      var ev2 = new Event('input', {
        bubbles: true
      });
      input.dispatchEvent(ev2);
    } catch (err) {
      console.debug(err);
    }
  }

  function get_categories_string(element, message) {
    var cat_names = _.get(element, 'ok_categories_names', []);

    var length = cat_names.length;
    message += ' ' + cmadel["for"] + ' ';

    _.each(cat_names, function (element, i) {
      message += i === 0 ? element : i != length - 1 ? ', ' + element : ' ' + cmadel.and + ' ' + element;
    });

    return message;
  }

  function print_message(status, methods) {
    var current_cart = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    var popover, popObject, has_cats, has_min_amount;
    var del_message_2;
    var del_message_3;

    if (cmadel.del_message_price_suffix == 0) {
      del_message_2 = cmadel.del_message_4;
      del_message_3 = cmadel.del_message_4;
    } else {
      del_message_2 = cmadel.del_message_2;
      del_message_3 = cmadel.del_message_3;
    }

    var formObject = $('#cma_adress_row #autocomplete_cma');
    var noticeObject = $('#cma_delivery_notice_wrapper');

    if (cmadel.delivery_color == 1) {
      noticeObject.addClass('cma-text-feedback');
    }

    var message = '';

    if (status !== 'ok') {
      switch (status) {
        case 'fail':
          message += cmadel.del_message_1;
          break;

        case 'precision_needed':
          message += cmadel.del_message_8;
          break;

        case 'address_not_valid':
          message += cmadel.del_message_5;
          break;

        default:
      }

      formObject.addClass('cma-fail');
      noticeObject.addClass('cma-fail');
    } else if (status == 'ok') {
      message = current_cart == 1 ? cmadel.current_cart_text : "";

      _.find(methods, function (element, i) {
        switch (i) {
          case 0:
            if (_.isNull(element)) {
              if (current_cart == 1) {
                message += message.length > 0 ? '<br/>' : '';
                message += cmadel.del_message_10;
                formObject.addClass('cma-fail');
                noticeObject.addClass('cma-fail');
              } else {
                formObject.addClass('cma-success');
                noticeObject.addClass('cma-success');
              }

              break;
            }

            formObject.addClass('cma-success');
            noticeObject.addClass('cma-success');
            var cost = cmadel.del_message_price_suffix == 1 ? element.del_price : '';
            message += message.length > 0 ? '<br/>' : '';
            message += element.cost == 0 ? del_message_3 : del_message_2 + cost + '. ';

            if (cmadel.del_message_price_suffix == 0) {
              return true;
            }

            message += element.package_is_simulated ? cmadel.simulated_text : '';
            break;

          case 1:
            if (_.isNull(element)) {
              break;
            } // code block


            has_min_amount = _.get(element, 'min_amount', 0) > 0;
            has_cats = !_.isEmpty(_.get(element, 'ok_categories_names', []));

            if (has_min_amount) {
              var non_suffix = cmadel.del_message_price_suffix == 1 ? cmadel.del_message_2 + element.del_price : cmadel.del_message_4;
              message += message.length > 0 ? '<br/>' : '';
              message += element.cost == 0 && cmadel.del_message_price_suffix == 1 ? cmadel.del_message_7 + element.min_amount_html : non_suffix + ' ' + cmadel.when_the_order_is_above + ' ' + element.min_amount_html;

              if (has_cats) {
                message = get_categories_string(element, message);
              }
            } else if (has_cats) {
              message += message.length > 0 ? '<br/>' : '';
              message += cmadel.del_message_price_suffix == 1 ? cmadel.del_message_2 + element.del_price : cmadel.del_message_4;
              message = get_categories_string(element, message);
            }

            message += '.';
            message += element.package_is_simulated ? cmadel.simulated_text : '';
            break;

          case 2:
            if (_.isNull(element)) {
              break;
            }

            has_min_amount = _.get(element, 'min_amount', 0) > 0;
            has_cats = !_.isEmpty(_.get(element, 'ok_categories_names', []));

            if (has_min_amount) {
              var _non_suffix = cmadel.del_message_price_suffix == 1 ? cmadel.del_message_2 + element.del_price : cmadel.del_message_4;

              message += message.length > 0 ? '<br/>' : '';
              message += element.cost == 0 && cmadel.del_message_price_suffix == 1 ? cmadel.del_message_7 + element.min_amount_html : _non_suffix + ' ' + cmadel.when_the_order_is_above + ' ' + element.min_amount_html;

              if (has_cats) {
                message = get_categories_string(element, message);
              }
            } else if (has_cats) {
              message += message.length > 0 ? '<br/>' : '';
              message += cmadel.del_message_price_suffix == 1 ? cmadel.del_message_2 + element.del_price : cmadel.del_message_4;
              message = get_categories_string(element, message);
            }

            message += '.';
            message += element.package_is_simulated ? cmadel.simulated_text : '';
            break;

          case 3:
            if (_.isNull(element)) {
              break;
            }

            message += message.length > 0 ? '<br/>' : '';
            message += cmadel.del_message_price_suffix == 1 ? cmadel.del_message_4 + '. ' + cmadel.del_message_shortcode : cmadel.del_message_4 + '.';
            break;

          default:
            return true;
        }
      });
    }

    if (cmadel.print_message == 1) {
      noticeObject.html(function () {
        return "<span id='cma_delivery_notice'>" + message + "</span>";
      }).fadeIn("slow");
    } else {
      popObject = $('#cma-pop-min');
      popover = popObject.attr('data-content', "<span id='cma_delivery_notice'>" + message + "</span>").data('bs.aropopover');
      var validation_class = formObject.hasClass('cma-success') ? 'success' : '';
      validation_class = formObject.hasClass('cma-fail') ? 'failure' : validation_class;
      show_popover(popObject, popover, validation_class);
    }
  }

  function evaluate_shipping_methods(response, latitude, longitude, validation_type, mode, is_from_map) {
    var outcome = $.Deferred();
    var the_response = response;

    if (the_response.status === true) {
      var ok_methods = [];

      if (the_response.woocommerce_methods !== null) {
        ok_methods = the_response.woocommerce_methods;
      } // For compatability with SZBD


      ok_methods_promise = get_ok_methods(the_response, ok_methods, latitude, longitude, validation_type);
      $.when(ok_methods_promise).then(function (met) {
        var methods = get_best_methods(met, response);

        if (_.isEmpty(methods)) {
          print_message('fail', methods, the_response.current_cart);
          outcome.resolve(false);
        } else {
          print_message('ok', methods, the_response.current_cart);
          outcome.resolve(true);
        }
      });
    } else {
      print_message('fail', [], the_response.current_cart);
      outcome.resolve(false);
    }

    return outcome.promise();
  } // New experiment method to create validation message
  // Returns array pos1 best method, pos2 2nd best with lowest cost, pos3 3rd best with lowest min amount, pos4


  function get_best_methods(methods, response) {
    var free_delivey_methods, partition_methods, restrictionless_methods, restriction_methods, lowest_cost_restriction_method, lowest_cost_restrictionless_method, toreturn; // When current cart validation

    if (response.current_cart == 1 && response.have_cart == 1) {
      // Collect pure conditionless free delivery methods	
      free_delivey_methods = _.filter(methods, function (element, i) {
        var method_min_amount = _.get(element, 'min_amount', 0);

        var cats_ok = _.get(element, 'cats_ok', true);

        var cost_zero = _.get(element, 'cost', 1) == 0; //test if free delivery

        if (cost_zero && cats_ok && (method_min_amount == 0 || method_min_amount <= response.tot_amount)) {
          return true;
        }
      }); // .. and return free delivery methods if exists

      if (free_delivey_methods.length) {
        return [free_delivey_methods[0]];
      } // Collect lowest cost method WITHOUT restrictions	


      partition_methods = _.partition(methods, function (element, i) {
        var method_min_amount = _.get(element, 'min_amount', 0);

        var cats_ok = _.get(element, 'cats_ok', true);

        if (cats_ok && (method_min_amount == 0 || method_min_amount <= response.tot_amount)) {
          return true;
        }
      });
      restrictionless_methods = partition_methods[0];
      lowest_cost_restrictionless_method = _.min(restrictionless_methods, function (o) {
        return o.cost;
      }); // Collect lowest cost method WITH restrictions, but categories ok

      restriction_methods = _.filter(partition_methods[1], function (element, i) {
        var cats_ok = _.get(element, 'cats_ok', true);

        if (cats_ok) {
          return true;
        }
      });
      lowest_cost_restriction_method = _.min(restriction_methods, function (o) {
        return o.cost;
      });

      if (_.isObject(lowest_cost_restrictionless_method) && !_.isObject(lowest_cost_restriction_method)) {
        return [lowest_cost_restrictionless_method];
      } else if (_.isObject(lowest_cost_restrictionless_method) && _.isObject(lowest_cost_restriction_method) && lowest_cost_restrictionless_method.cost <= lowest_cost_restriction_method.cost) {
        return [lowest_cost_restrictionless_method];
      } else if (_.isObject(lowest_cost_restrictionless_method) && _.isObject(lowest_cost_restriction_method) && lowest_cost_restrictionless_method.cost > lowest_cost_restriction_method.cost) {
        return [lowest_cost_restrictionless_method, lowest_cost_restriction_method];
      } else if (!_.isObject(lowest_cost_restrictionless_method) && _.isObject(lowest_cost_restriction_method)) {
        // Collect also lowest minimum order value	
        restriction_methods = _.filter(restriction_methods, function (element, i, list) {
          var method_min_amount = _.get(element, 'min_amount', false);

          if (method_min_amount !== false && method_min_amount > 0) {
            return true;
          }
        });
        lowest_min_amount_restriction_method = _.min(restriction_methods, function (o) {
          return o.min_amount;
        });
        toreturn = _.isObject(lowest_cost_restriction_method) ? [null, lowest_cost_restriction_method] : [];

        if (_.isObject(lowest_cost_restriction_method) && _.isObject(lowest_min_amount_restriction_method) && lowest_cost_restriction_method.value_id !== lowest_min_amount_restriction_method.value_id) {
          toreturn.push(lowest_min_amount_restriction_method);
        }

        return toreturn;
      } else if (partition_methods[1].length) {
        restriction_methods = _.filter(partition_methods[1], function (element, i, list) {
          var method_min_amount = _.get(element, 'min_amount', false);

          if (method_min_amount == false && method_min_amount == 0) {
            return true;
          }
        });
        lowest_cost_restriction_method = _.min(restriction_methods, function (o) {
          return o.cost;
        });

        if (_.isObject(lowest_cost_restriction_method)) {
          toreturn = [null, lowest_cost_restriction_method];
          return toreturn; //toreturn.push(  lowest_min_amount_restriction_method);
        } else {
          var cats_ok_methods = _.partition(partition_methods[1], function (element, i, list) {
            var cats_ok = _.get(element, 'cats_ok', true);

            if (cats_ok) {
              return true;
            }
          });

          if (_.isObject(_.first(cats_ok_methods[0]))) {
            return [null, _.first(cats_ok_methods)];
          } else if (_.isObject(_.first(cats_ok_methods[1]))) {
            return [null, _.first(cats_ok_methods[1])];
          }
        }
      }

      return []; // For non current cart validations or empty carts
    } else {
      // Collect pure conditionless free delivery methods	
      free_delivey_methods = _.filter(methods, function (element, i, list) {
        var method_min_amount = _.get(element, 'min_amount', 0);

        var has_shortcode = _.get(element, 'rate_has_shortcode', false);

        var has_no_cats = _.isEmpty(_.get(element, 'ok_categories', ''));

        var cost_zero = _.get(element, 'cost', 1) == 0; //test if free delivery

        if (!has_shortcode && cost_zero && has_no_cats && method_min_amount == 0) {
          return true;
        }
      }); // .. and return free delivery methods if exists

      if (free_delivey_methods.length) {
        return [free_delivey_methods[0]];
      } // Collect lowest cost method WITHOUT restrictions	


      partition_methods = _.partition(methods, function (element, i, list) {
        var method_min_amount = _.get(element, 'min_amount', 0);

        var has_no_cats = _.isEmpty(_.get(element, 'ok_categories', ''));

        var has_shortcode = _.get(element, 'rate_has_shortcode', false);

        if (!has_shortcode && has_no_cats && method_min_amount == 0) {
          return true;
        }
      });
      restrictionless_methods = partition_methods[0];
      lowest_cost_restrictionless_method = _.min(restrictionless_methods, function (o) {
        return o.cost;
      }); // Collect lowest cost method WITH restrictions	

      restriction_methods = _.filter(partition_methods[1], function (element, i, list) {
        var has_shortcode = _.get(element, 'rate_has_shortcode', false);

        var has_no_cats = _.isEmpty(_.get(element, 'ok_categories', ''));

        if (!has_shortcode && has_no_cats) {
          return true;
        }
      });

      var pure_shortcode_methods = _.filter(partition_methods[1], function (element, i, list) {
        var method_min_amount = _.get(element, 'min_amount', 0);

        var has_shortcode = _.get(element, 'rate_has_shortcode', false);

        var has_no_cats = _.isEmpty(_.get(element, 'ok_categories', ''));

        if (has_shortcode && has_no_cats && method_min_amount == 0) {
          return true;
        }
      });

      lowest_cost_restriction_method = _.min(restriction_methods, function (o) {
        return o.cost;
      });

      if (_.isObject(lowest_cost_restrictionless_method) && !_.isObject(lowest_cost_restriction_method)) {
        return [lowest_cost_restrictionless_method];
      } else if (_.isObject(lowest_cost_restrictionless_method) && _.isObject(lowest_cost_restriction_method) && lowest_cost_restrictionless_method.cost <= lowest_cost_restriction_method.cost) {
        return [lowest_cost_restrictionless_method];
      } else if (_.isObject(lowest_cost_restrictionless_method) && _.isObject(lowest_cost_restriction_method) && lowest_cost_restrictionless_method.cost > lowest_cost_restriction_method.cost) {
        return [lowest_cost_restrictionless_method, lowest_cost_restriction_method];
      } else if (!_.isObject(lowest_cost_restrictionless_method) && _.isObject(lowest_cost_restriction_method)) {
        // Collect also lowest minimum order value	
        restriction_methods = _.filter(partition_methods[1], function (element, i, list) {
          var method_min_amount = _.get(element, 'min_amount', false);

          var has_shortcode = _.get(element, 'rate_has_shortcode', false);

          if (!has_shortcode && method_min_amount !== false && method_min_amount > 0) {
            return true;
          }
        });
        lowest_min_amount_restriction_method = _.min(restriction_methods, function (o) {
          return o.min_amount;
        });
        toreturn = [null, lowest_cost_restriction_method];

        if (_.isObject(lowest_min_amount_restriction_method) && lowest_cost_restriction_method.value_id !== lowest_min_amount_restriction_method.value_id && lowest_cost_restriction_method.min_amount != lowest_min_amount_restriction_method.min_amount) {
          toreturn.push(lowest_min_amount_restriction_method);
        } else {
          var restriction_methods_min_amount = _.filter(partition_methods[1], function (element, i, list) {
            var has_shortcode = _.get(element, 'rate_has_shortcode', false);

            if (!has_shortcode) {
              return true;
            }
          });

          var lowest_cost_min_amount = _.min(restriction_methods_min_amount, function (o) {
            return o.cost;
          });

          if (_.isObject(lowest_cost_min_amount) && lowest_cost_restriction_method.value_id !== lowest_cost_min_amount.value_id) {
            toreturn.push(lowest_cost_min_amount);
          }
        }

        return toreturn;
      } else if (_.isObject(pure_shortcode_methods[0])) {
        return [null, null, null, pure_shortcode_methods];
      } else if (_.isObject(_.first(partition_methods[1]))) {
        var restriction_methods_with_any_cat = _.filter(partition_methods[1], function (element) {
          var has_cats = !_.isEmpty(_.get(element, 'ok_categories', ''));

          if (has_cats) {
            return true;
          }
        });

        if (_.isObject(_.first(restriction_methods_with_any_cat))) {
          return [null, _.first(restriction_methods_with_any_cat)];
        }

        restriction_methods_with_any_shortcode = _.filter(partition_methods[1], function (element) {
          var has_shortcode = _.get(element, 'rate_has_shortcode', false);

          if (has_shortcode) {
            return true;
          }
        });

        if (_.isObject(_.first(restriction_methods_with_any_shortcode))) {
          return [null, null, null, _.first(restriction_methods_with_any_shortcode)];
        }
      }

      return [];
    }
  }

  function get_ok_methods(the_response, ok_methods, latitude, longitude, validation_type) {
    var ok_methods2 = $.Deferred();
    var ok_methods_reserve = [];
    var drive_time_car_Promise, drive_time_bike_Promise, drive_dist_Promise, bicycle_dist_Promise, radius_Promise, delivery_address;

    if (the_response.status !== true || the_response.szbd_zones == null || the_response.szbd_extra === null) {
      ok_methods2.resolve(ok_methods);
    }

    if (the_response.szbd_extra !== null && parseInt(the_response.szbd_extra.version < 2)) {
      the_response.szbd_zones.forEach(function (element) {
        var path = [];
        var i;

        for (i = 0; i < element.geo_coordinates.length; i++) {
          path.push(new google.maps.LatLng(element.geo_coordinates[i][0], element.geo_coordinates[i][1]));
        }

        var polygon = new google.maps.Polygon({
          paths: path
        });
        var location = new google.maps.LatLng(latitude, longitude);
        var address_is_in_zone = google.maps.geometry.poly.containsLocation(location, polygon);

        if (address_is_in_zone) {
          ok_methods.push(element);
        }

        if (index == the_response.szbd_zones.length - 1) {
          ok_methods2.resolve(ok_methods);
        }
      });
    } else if (the_response.szbd_extra !== null && the_response.szbd_extra.is_prem === false) {
      drive_time_car_Promise = false;
      drive_time_bike_Promise = false;
      drive_dist_Promise = false;
      bicycle_dist_Promise = false;
      delivery_address = {
        lat: latitude,
        lng: longitude
      };
      radius_Promise = the_response.szbd_extra.do_radius && delivery_address !== null && latitude !== null && longitude !== null ? calcRadius(delivery_address, the_response.store_address, false) : false;
      $.when(drive_time_car_Promise, drive_time_bike_Promise, drive_dist_Promise, bicycle_dist_Promise, radius_Promise).then(function (driving_car, driving_bike, driving_dist, bicycling_dist, radius) {
        // Check if the custom delivery method is applicable
        if (the_response.status === true && !(the_response.szbd_zones === null || the_response.szbd_zones === undefined || the_response.szbd_zones.length == 0)) {
          the_response.szbd_zones.forEach(function (element, index) {
            if (element.drawn_map !== false && latitude !== null && longitude !== null) {
              var path = [];
              var i;

              for (i = 0; element.geo_coordinates !== null && i < element.geo_coordinates.length; i++) {
                path.push(new google.maps.LatLng(element.geo_coordinates[i][0], element.geo_coordinates[i][1]));
              }

              var polygon = new google.maps.Polygon({
                paths: path
              });
              var location = new google.maps.LatLng(latitude, longitude);
              var address_is_in_zone = google.maps.geometry.poly.containsLocation(location, polygon);
            } else if (element.max_radius !== false && latitude !== null && longitude !== null) {
              var max_radius = element.distance_unit == 'miles' ? element.max_radius.radius * 1609.344 : element.max_radius.radius * 1000;
              var max_ok = max_radius > radius && radius !== false;

              if (element.max_radius.bool && !max_ok) {//error_type.push(szbd.checkout_string_3 + ' ' + element.max_radius.radius + element.distance_unit);
              }
            }

            var condition_0 = typeof address_is_in_zone == 'undefined' || address_is_in_zone;
            var condition_1 = typeof max_ok == 'undefined' || max_ok;
            var condition_2 = typeof max_driving_distance_ok == 'undefined' || max_driving_distance_ok;
            var condition_3 = typeof max_driving_time_car == 'undefined' || max_driving_time_car;
            var condition_4 = typeof max_driving_time_bike == 'undefined' || max_driving_time_bike;
            var ok;

            if (element.drawn_map.bool && !condition_0) {
              ok = false;
            } else if (element.max_radius.bool && !condition_1) {
              ok = false;
            } else if (element.max_driving_distance.bool && !condition_2) {
              ok = false;
            } else if (element.max_driving_time_car.bool && !condition_3) {
              ok = false;
            } else if (element.max_driving_time_bike.bool && !condition_4) {
              ok = false;
            } else if (typeof address_is_in_zone !== 'undefined' && address_is_in_zone || typeof max_ok !== 'undefined' && max_ok || typeof max_driving_distance_ok !== 'undefined' && max_driving_distance_ok || typeof max_driving_time_car !== 'undefined' && max_driving_time_car || typeof max_driving_time_bike !== 'undefined' && max_driving_time_bike) {
              ok = true;
            } else if (typeof address_is_in_zone == 'undefined' && typeof max_ok == 'undefined' && typeof max_driving_distance_ok == 'undefined' && typeof max_driving_time_car == 'undefined' && typeof max_driving_time_bike == 'undefined') {
              ok = true;
            } else {
              ok = false;
            }

            if (ok) {
              ok_methods.push(element);
            }

            if (index == the_response.szbd_zones.length - 1) {
              ok_methods2.resolve(ok_methods);
            }
          });
        }
      });
    } else if (the_response.szbd_extra !== null && the_response.szbd_extra.is_prem === true) {
      delivery_address = {
        lat: latitude,
        lng: longitude
      };
      var origins = the_response.szbd_extra.default_origin !== true ? get_origins_promises(the_response.szbd_zones, delivery_address, latitude, longitude, the_response.store_address) : false;
      radius_Promise = the_response.szbd_extra.do_radius && delivery_address !== null && latitude !== null && longitude !== null && the_response.szbd_extra.default_origin == true ? calcRadius(delivery_address, the_response.store_address, false) : false;

      if (the_response.szbd_extra.delivery_duration_driving !== false || the_response.szbd_extra.distance_driving !== false) {
        drive_time_car_Promise = drive_dist_Promise = [the_response.szbd_extra.delivery_duration_driving, the_response.szbd_extra.distance_driving];
      } else {
        drive_time_car_Promise = drive_dist_Promise = the_response.szbd_extra.default_origin == true && (the_response.szbd_extra.do_driving_time_car || the_response.szbd_extra.do_driving_dist || the_response.szbd_extra.do_dynamic_rate_car) && delivery_address !== null && latitude !== null && longitude !== null ? calcRoute(latitude, longitude, the_response.store_address, 'DRIVING') : false;
      }

      if (the_response.szbd_extra.delivery_duration_bicycle !== false || the_response.szbd_extra.distance_bicycle !== false) {
        drive_time_bike_Promise = bicycle_dist_Promise = [the_response.szbd_extra.delivery_duration_bicycle, the_response.szbd_extra.distance_bicycle];
      } else {
        drive_time_bike_Promise = bicycle_dist_Promise = the_response.szbd_extra.default_origin == true && (the_response.szbd_extra.do_driving_time_bike || the_response.szbd_extra.do_bike_dist || the_response.szbd_extra.do_dynamic_rate_bike) && delivery_address !== null && latitude !== null && longitude !== null ? calcRoute(latitude, longitude, the_response.store_address, 'BICYCLING') : false;
      }

      $.when(drive_time_car_Promise, drive_time_bike_Promise, drive_dist_Promise, bicycle_dist_Promise, radius_Promise, origins).then(function (driving_car, driving_bike, driving_dist, bicycling_dist, radius, origins1) {
        if (!_.isArray(origins1) && _.isObject(origins1)) {
          origins1 = [origins1];
        } // Check if the custom delivery method is applicable


        if (the_response.status === true && !(the_response.szbd_zones === null || the_response.szbd_zones === undefined || the_response.szbd_zones.length == 0)) {
          the_response.szbd_zones.forEach(function (element, index) {
            if (element.drawn_map !== false) {
              var path = [];
              var i;

              for (i = 0; element.geo_coordinates !== null && i < element.geo_coordinates.length; i++) {
                path.push(new google.maps.LatLng(element.geo_coordinates[i][0], element.geo_coordinates[i][1]));
              }

              var polygon = new google.maps.Polygon({
                paths: path
              });
              var location = new google.maps.LatLng(latitude, longitude);
              var address_is_in_zone = google.maps.geometry.poly.containsLocation(location, polygon);
            } else if (element.max_radius !== false) {
              radius = _.isNull(element.shipping_origin) ? radius : _.chain(origins1).find(function (el) {
                return _.has(el, 'rad') && element.value_id == el.id;
              }).get('rad', null).value();
              var max_radius = element.distance_unit == 'miles' ? element.max_radius.radius * 1609.344 : element.max_radius.radius * 1000;
              var max_ok = !_.isUndefined(radius) && radius !== false && max_radius > radius;

              if (element.max_radius.bool && !max_ok) {//error_type.push(szbd.checkout_string_3 + ' ' + element.max_radius.radius + element.distance_unit);
              }
            }

            if (element.max_driving_distance !== false || element.max_driving_time_car !== false) {
              var car_El = _.isNull(element.shipping_origin) ? driving_dist : _.first(_(_.filter(origins1, function (obj) {
                return obj.id == element.value_id && _.has(obj, 'car');
              })).pluck('car'));
              var max_driving_distance_ok;
              var max_driving_time_car;
              var max_dist = element.max_driving_distance !== false ? element.distance_unit == 'miles' ? element.max_driving_distance.distance * 1609.344 : element.max_driving_distance.distance * 1000 : null;
              max_driving_distance_ok = element.max_driving_distance !== false ? !_.isUndefined(car_El) && 1 in car_El && max_dist > car_El[1] : undefined; //alert('IN WHEN max_driving_distance_ok: ' + max_driving_distance_ok);

              max_driving_time_car = element.max_driving_time_car !== false ? !_.isUndefined(car_El) && 0 in car_El && element.max_driving_time_car.time * 60 > car_El[0] : undefined;
            }

            if (element.max_bike_distance !== false || element.max_driving_time_bike !== false) {
              var bike_El = _.isNull(element.shipping_origin) ? bicycling_dist : _.first(_(_.filter(origins1, function (obj) {
                return obj.id == element.value_id && _.has(obj, 'bike');
              })).pluck('bike'));
              var max_bike_distance_ok;
              var max_driving_time_bike;

              var _max_dist = element.max_bike_distance !== false ? element.distance_unit == 'miles' ? element.max_bike_distance.distance * 1609.344 : element.max_bike_distance.distance * 1000 : null;

              max_bike_distance_ok = element.max_bike_distance !== false ? !_.isUndefined(bike_El) && 1 in bike_El && _max_dist > bike_El[1] : undefined;
              max_driving_time_bike = element.max_driving_time_bike !== false ? !_.isUndefined(bike_El) && 0 in bike_El && element.max_driving_time_bike.time * 60 > bike_El[0] : undefined;
            }

            var condition_0 = typeof address_is_in_zone == 'undefined' || address_is_in_zone;
            var condition_1 = typeof max_ok == 'undefined' || max_ok;
            var condition_2 = typeof max_driving_distance_ok == 'undefined' || max_driving_distance_ok;
            var condition_2_ = typeof max_bike_distance_ok == 'undefined' || max_bike_distance_ok;
            var condition_3 = typeof max_driving_time_car == 'undefined' || max_driving_time_car;
            var condition_4 = typeof max_driving_time_bike == 'undefined' || max_driving_time_bike;
            var ok;

            if (element.drawn_map.bool && !condition_0) {
              ok = false;
            } else if (element.max_radius.bool && !condition_1) {
              ok = false;
            } else if (element.max_driving_distance.bool && !condition_2) {
              ok = false;
            } else if (element.max_bike_distance.bool && !condition_2_) {
              ok = false;
            } else if (element.max_driving_time_car.bool && !condition_3) {
              ok = false;
            } else if (element.max_driving_time_bike.bool && !condition_4) {
              ok = false;
            } else if (typeof address_is_in_zone !== 'undefined' && address_is_in_zone || typeof max_ok !== 'undefined' && max_ok || typeof max_driving_distance_ok !== 'undefined' && max_driving_distance_ok || typeof max_driving_time_car !== 'undefined' && max_driving_time_car || typeof max_driving_time_bike !== 'undefined' && max_driving_time_bike || typeof max_bike_distance_ok !== 'undefined' && max_bike_distance_ok) {
              ok = true;
            } else if (typeof address_is_in_zone == 'undefined' && typeof max_ok == 'undefined' && typeof max_driving_distance_ok == 'undefined' && typeof max_bike_distance_ok == 'undefined' && typeof max_driving_time_car == 'undefined' && typeof max_driving_time_bike == 'undefined') {
              ok = true;
            } else {
              ok = false;
            }

            var min_amount_ok = element.min_amount <= the_response.tot_amount;

            if (ok) {
              var unit_converter = element.distance_unit == 'miles' ? 1 / 1.6093 : 1;

              if (element.cost == 0 && element.rate_mode == 'fixed_and_distance') {
                element.cost_changed = true;
                element.cost = element.transport_mode == 'car' ? driving_dist[1] / 1000 * parseFloat(element.rate_distance) * unit_converter + parseFloat(element.rate_fixed) : bicycling_dist[1] / 1000 * parseFloat(element.rate_distance) * unit_converter + parseFloat(element.rate_fixed);
              } else if (element.cost == 0 && element.rate_mode == 'distance') {
                element.cost = element.transport_mode == 'car' ? driving_dist[1] / 1000 * parseFloat(element.rate_distance) * unit_converter : bicycling_dist[1] / 1000 * parseFloat(element.rate_distance) * unit_converter;
                element.cost_changed = true;
              }

              if (min_amount_ok) {
                ok_methods.push(element);
              } else {
                ok_methods.push(element);
              }
            }

            if (index == the_response.szbd_zones.length - 1) {
              if (ok_methods.length > 0) {
                ok_methods2.resolve(ok_methods);
              } else {
                ok_methods2.resolve(ok_methods_reserve);
              }
            }
          });
        } else {
          ok_methods2.resolve(ok_methods);
        }
      });
    }

    return ok_methods2.promise();
  }

  function get_origins_promises(zones, delivery_address, latitude, longitude, store_address) {
    var promises = [];
    zones.forEach(function (element, index) {
      if (_.isNull(element.shipping_origin)) {
        element.shipping_origin = store_address;
      }

      if (element.max_radius !== false && delivery_address !== null) {
        var def_radius = new $.Deferred();
        $.when(calcRadius(delivery_address, element.shipping_origin, true)).then(function (r) {
          def_radius.resolve({
            id: element.value_id,
            rad: r
          });
        });
        promises.push(def_radius);
      }

      if (element.max_driving_distance !== false || element.max_driving_time_car !== false) {
        var def2_max_driving = new $.Deferred();
        $.when(calcRoute(latitude, longitude, element.shipping_origin, 'DRIVING')).then(function (r) {
          def2_max_driving.resolve({
            id: element.value_id,
            car: r
          });
        });
        promises.push(def2_max_driving);
      }

      if (element.max_bike_distance !== false || element.max_driving_time_bike !== false) {
        var def2_max_bike = new $.Deferred();
        $.when(calcRoute(latitude, longitude, element.shipping_origin, 'BICYCLING')).then(function (r) {
          def2_max_bike.resolve({
            id: element.value_id,
            bike: r
          });
        });
        promises.push(def2_max_bike);
      }
    });
    return $.when.apply(undefined, promises).then();
  }

  function calcRadius(delivery_address, store_address, has_address) {
    var radius = $.Deferred();
    var store_loc, store_loc_;
    delivery_address = new google.maps.LatLng(delivery_address.lat, delivery_address.lng);

    if (_.isObject(store_address) && _.has(store_address, 'lat') && _.has(store_address, 'lng')) {
      store_loc = new google.maps.LatLng(store_address.lat, store_address.lng);
    } else if (typeof store_address == 'string') {
      store_loc_ = store_address.split(',', 2);
      store_loc = typeof store_loc_[0] !== 'undefined' && typeof store_loc_[1] !== 'undefined' && !isNaN(store_loc_[0]) && !isNaN(store_loc_[1]) ? new google.maps.LatLng(parseFloat(store_loc_[0]), parseFloat(store_loc_[1])) : store_address;
    } else {
      store_loc = store_address.store_address + ',' + store_address.store_postcode + ',' + store_address.store_city + ',' + store_address.store_state + ',' + store_address.store_country;
    }

    if (typeof store_loc == 'string') {
      var geocode_storeaddress = new google.maps.Geocoder();
      geocode_storeaddress.geocode({
        'address': store_loc
      }, function (results, status) {
        if (status == 'OK') {
          var r = compute_radius(results[0].geometry.location, delivery_address);
          radius.resolve(r);
        } else {
          radius.resolve('error');
        }
      });
    } else {
      var t = compute_radius(store_loc, delivery_address);
      radius.resolve(t);
    }

    return radius.promise();
  }

  function compute_radius(s, d) {
    return google.maps.geometry.spherical.computeDistanceBetween(s, d);
  }

  function calcRoute(lati, longi, store_address, mode) {
    var N = 0;
    var store_loc, store_loc_;
    var time_def = $.Deferred();

    if (_.isObject(store_address) && _.has(store_address, 'lat') && _.has(store_address, 'lng')) {
      store_loc = new google.maps.LatLng(store_address.lat, store_address.lng);
    } else if (typeof store_address == 'string') {
      store_loc_ = store_address.split(',', 2);
      store_loc = typeof store_loc_[0] !== 'undefined' && typeof store_loc_[1] !== 'undefined' && !isNaN(store_loc_[0]) && !isNaN(store_loc_[1]) ? new google.maps.LatLng(parseFloat(store_loc_[0]), parseFloat(store_loc_[1])) : store_address;
    } else {
      store_loc = store_address.store_address + ',' + store_address.store_postcode + ',' + store_address.store_city + ',' + store_address.store_state + ',' + store_address.store_country;
    }

    if (_.isNull(lati) || _.isNull(longi)) {
      time_def.resolve('error');
      return time_def.promise();
    }

    var request = {
      origin: store_loc,
      destination: {
        lat: lati,
        lng: longi
      },
      travelMode: mode
      /*	drivingOptions: {
      		departureTime: new Date(Date.now() + N), // for the time N milliseconds from now.
      		trafficModel: 'bestguess'
      	}*/

    };
    var directionsService = new google.maps.DirectionsService();
    directionsService.route(request, function (response, status) {
      if (status == 'OK') {
        var time = typeof response.routes[0].legs[0].duration_in_traffic !== 'undefined' ? response.routes[0].legs[0].duration_in_traffic.value : response.routes[0].legs[0].duration.value;
        var dist = response.routes[0].legs[0].distance.value;
        var del_address = response.routes[0].legs[0].end_address;
        time_def.resolve([time, dist, del_address]);
      } else {
        time_def.resolve('error');
      }
    });
    return time_def.promise();
  }

  function insert_from_autocomplete(results) {
    if (results === false) {
      jQuery('#cma_address_fractions').trigger('reset');
      return;
    }

    var formFields = {
      'cma_bshipping_streetnumber': '',
      'cma_bshipping_address_1': '',
      'cma_bshipping_address_2': '',
      'cma_bshipping_city': '',
      'cma_adm1_short': '',
      'cma_adm1_long': '',
      'cma_adm2_short': '',
      'cma_adm2_long': '',
      'cma_bshipping_postcode': '',
      'cma_bshipping_country': ''
    };
    var formFieldsValue = {
      'cma_bshipping_streetnumber': '',
      'cma_bshipping_address_1': '',
      'cma_bshipping_address_2': '',
      'cma_bshipping_city': '',
      'cma_adm1_short': '',
      'cma_adm1_long': '',
      'cma_adm2_short': '',
      'cma_adm2_long': '',
      'cma_bshipping_postcode': '',
      'cma_bshipping_country': ''
    };

    for (var field in formFields) {
      formFields[field] = field;
    }

    var component_form = [{
      'street_number': ['cma_bshipping_streetnumber', 'short_name'],
      'route': ['cma_bshipping_address_1', 'long_name'],
      'locality': ['cma_bshipping_city', 'long_name'],
      'postal_town': ['cma_bshipping_city', 'long_name'],
      'sublocality_level_1': ['cma_bshipping_city', 'long_name'],
      'administrative_area_level_1': ['cma_adm1_short', 'short_name'],
      'administrative_area_level_2': ['cma_adm2_short', 'short_name'],
      'country': ['cma_bshipping_country', 'short_name'],
      'postal_code': ['cma_bshipping_postcode', 'short_name']
    }, {
      'administrative_area_level_1': ['cma_adm1_long', 'long_name'],
      'administrative_area_level_2': ['cma_adm2_long', 'long_name']
    }];
    var place = results[0];

    if (typeof place.address_components !== 'undefined') {
      for (var i = 0; i < place.address_components.length; i++) {
        var addressType = place.address_components[i].types[0];

        if (addressType == 'country') {
          var val = place.address_components[i]['short_name'];
          document.getElementById('cma_bshipping_country').value = val;
        }
      }
    }

    var current_country = document.getElementById("cma_bshipping_country").value;

    for (var k = 0; k < component_form.length; k++) {
      var type = '';

      for (var field in place.address_components) {
        for (var t in place.address_components[field].types) {
          for (var f in component_form[k]) {
            var types = place.address_components[field].types;

            if (f == types[t]) {
              var prop = component_form[k][f][1];

              if (place.address_components[field].hasOwnProperty(prop)) {
                formFieldsValue[component_form[k][f][0]] = place.address_components[field][prop];
              }
            }
          }
        }
      }
    }

    for (var f in formFieldsValue) {
      if (f == 'cma_bshipping_country') {
        document.getElementById(f).value = formFieldsValue[f];
      } else {
        if (document.getElementById(f) === null) {
          continue;
        } else {
          document.getElementById(f).value = formFieldsValue[f];
        }
      }
    }

    var a = document.getElementById('autocomplete_cma').value;
    var c = document.getElementById('cma_bshipping_streetnumber').value;
    var b = document.getElementById('cma_bshipping_address_1').value;
    var streetaddress = a.substring(0, a.indexOf(','));

    if (c !== '' && b !== '') {
      document.getElementById('cma_bshipping_address_1').value = street_number_come_first(a, c) ? c + ' ' + b : b + ' ' + c;
      maybe_adjust_address(streetaddress, b, results);
      return;
    }

    var streetnumber = a.split(/[,]/)[1];

    if (streetnumber && streetnumber.toLowerCase().indexOf(c) >= 0 && c !== '') {
      document.getElementById('cma_bshipping_address_1').value = street_number_come_first(a, streetnumber) ? streetnumber + ' ' + streetaddress : streetaddress + ' ' + streetnumber;
    } else {
      document.getElementById('cma_bshipping_address_1').value = streetaddress;
    }

    maybe_adjust_address(streetaddress, b, results);
    return;
  }

  function maybe_adjust_address(streetaddress, b, results) {
    // Maybe add establishment name to address
    if (b != streetaddress && !_.intersection(results[0].types, ['street_address']).length && _.intersection(results[0].types, ['establishment']).length) {
      document.getElementById('cma_bshipping_address_1').value = streetaddress + ', ' + document.getElementById('cma_bshipping_address_1').value;
    }
  }

  function street_number_come_first(a, c) {
    return _.isNumber(+c.charAt(0)) && !_.isNaN(+c.charAt(0)) && a.charAt(0) === c.charAt(0);
  }

  function cma_check_address(mode) {
    var deferred = $.Deferred();
    var addr = document.getElementById("autocomplete_cma"); // Get geocoder instance

    var geocoder = new google.maps.Geocoder(); // Geocode the address

    if (document.getElementById('cma_bshipping_address_1').value != 'ok' && mode != 'checkout') {
      insert_from_autocomplete(false);
      deferred.resolve([false, null, null]);
    }

    geocoder.geocode({
      'address': addr.value
    }, function (results, status) {
      var accept_status = _.toArray(cmadel.result_types);

      if (status === google.maps.GeocoderStatus.OK && typeof results[0].address_components !== 'undefined') {
        var country = getCountry(results[0].address_components);

        if (country == 'AO') {
          accept_status.push('route');
        } else if (country == 'IE') {
          accept_status.push('postal_code');
        }
      }

      if (status === google.maps.GeocoderStatus.OK && _.intersection(results[0].types, accept_status).length) {
        if (mode === 'checkout' && typeof results[0].formatted_address !== 'undefined') {
          $('#autocomplete_cma').val(results[0].formatted_address);
        }

        insert_from_autocomplete(results);
        var latitude = results[0].geometry.location.lat();
        var longitude = results[0].geometry.location.lng();
        deferred.resolve([true, latitude, longitude]);
      } else if (status === google.maps.GeocoderStatus.OK && results[0].types[0] == "route") {
        if (cmadel.pick_from_map == 'at_fail') {
          $('#cma_precise_streetnumber').aromodal('show');
          insert_from_autocomplete(results);
          initMap(results[0].geometry.location);

          if (mode == 'checkout') {
            $.when(wait_for_map_location('address', mode)).then(function (r) {
              var is_validated = true;
              deferred.resolve([r[0], null, null, is_validated]);
            });
          } else {
            deferred.resolve([false, null, null]);
          }
        } else {
          print_message('precision_needed', null, null);
          insert_from_autocomplete(false);
          deferred.resolve([false, null, null]);
        }
      } else if (status === google.maps.GeocoderStatus.OK) {
        if (cmadel.pick_from_map == 'at_fail') {
          initMap(results[0].geometry.location);
          $('#cma_precise_streetnumber').aromodal('show');

          if (mode == 'checkout') {
            $.when(wait_for_map_location('address', mode)).then(function (r) {
              deferred.resolve(r);
            });
          } else {
            deferred.resolve([false, null, null]);
          }
        } else {
          insert_from_autocomplete(false);
          print_message('address_not_valid', null, null);
          deferred.resolve([false, null, null]);
        }
      } else {
        insert_from_autocomplete(false);
        print_message('address_not_valid', null, null);
        deferred.resolve([false, null, null]);
      }
    });
    return deferred.promise();
  }

  function preinitMap() {
    try {
      var mapOptions = {
        zoom: 1,
        center: {
          lat: 0,
          lng: 0
        },
        disableDefaultUI: true,
        zoomControl: true
      };
      map = new google.maps.Map(document.getElementById('cma_map'), mapOptions);
    } catch (err) {}
  }

  function initMap(uluru) {
    try {
      var mapOptions;
      var markerOptions;

      if (map === 'undefined') {
        mapOptions = {
          zoom: 15,
          center: {
            lat: 0,
            lng: 0
          },
          disableDefaultUI: true,
          zoomControl: true
        };
        map = new google.maps.Map(document.getElementById('cma_map'), mapOptions);
      } else if (map !== 'undefined') {
        map.setCenter(uluru);
        map.setZoom(15);

        if (marker) {
          marker.setPosition(uluru);
          placeMarker(uluru);
        } else {
          marker = new google.maps.Marker({
            position: uluru,
            map: map,
            draggable: true
          });
          placeMarker(uluru);
          google.maps.event.addListener(marker, 'dragend', function (e) {
            placeMarker(e.latLng);
          });
        }
      }

      infobox = infobox == null ? new google.maps.InfoWindow() : infobox;
      jQuery('#cma_map').height(444);
      google.maps.event.addListener(map, 'click', function (event) {
        if (marker) {
          marker.setPosition(event.latLng);
          placeMarker(event.latLng);
        } else {
          marker = new google.maps.Marker({
            position: event.latLng,
            map: map,
            draggable: true
          });
          placeMarker(event.latLng);
          google.maps.event.addListener(marker, 'dragend', function (e) {
            placeMarker(e.latLng);
          });
        }
      });
    } catch (err) {}
  }

  function placeMarker(location) {
    try {
      geolocate_marker(location);
      jQuery('.cma-confirm-marker:not(.cma-conform-marker-checkout)').off('click.cma-map').on('click.cma-map', function () {
        var theblock = jQuery(this);

        if ($.fn.blockUI != 'undefined') {
          theblock.addClass('processing').block({
            message: null,
            overlayCSS: {
              opacity: 0.7
            }
          });
        }

        var mode = 'initial';
        var is_from_map = true;
        var evaluate = check_map_marker_position(marker.getPosition(), mode, is_from_map);
        $.when(evaluate).then(function (evalu) {
          if (evalu) {
            jQuery(document).trigger('cma_validation_ok');
          } else {
            jQuery(document).trigger('cma_validation_not_ok');
          }

          $('#cma_precise_streetnumber').aromodal('hide');

          if ($.fn.blockUI != 'undefined') {
            theblock.removeClass('processing').unblock();
          }
        });
      });
    } catch (err) {}
  }

  function geolocate_marker(latlng) {
    var georesult = $.Deferred();
    var geocoder = new google.maps.Geocoder();
    geocoder.geocode({
      'location': latlng
    }, function (results, status) {
      if (status === "OK") {
        if (results[0]) {
          infobox.setContent(results[0].formatted_address);
          infobox.open(map, marker);
          georesult.resolve(results);
        } else {
          georesult.resolve(false);
        }
      } else {
        georesult.resolve(false);
      }
    });
    return georesult.promise();
  }

  function check_map_marker_position(latlng, mode, is_from_map) {
    // Post shipping address to server
    var outcome = $.Deferred();
    var geodone = geolocate_marker(latlng);
    $.when(geodone).then(function (results) {
      if (results === false) {
        outcome.resolve([results]);
      }

      insert_from_autocomplete(false);
      jQuery('#cma_bshipping_address_1').val('ok');
      var postalCode = '';
      var country = '';
      var cma_adm1_long = '';
      var cma_adm1_short = '';
      var cma_adm2_long = '';
      var cma_adm2_short = '';
      var theblock = mode == 'initial' ? jQuery('#cma_shipping_form, .cma-confirm-marker') : jQuery('.cma-conform-marker-checkout');

      if ($.fn.blockUI != 'undefined') {
        theblock.addClass('processing').block({
          message: null,
          overlayCSS: {
            background: '#fff',
            opacity: 0.6
          }
        });
      }

      jQuery('#autocomplete_cma').val(results[0].formatted_address);
      insert_from_autocomplete(results);
      var latitude = latlng.lat();
      var longitude = latlng.lng();
      var mode = 'initial';
      var cma_country = document.getElementById("cma_bshipping_country").value;
      var cma_postcode = document.getElementById("cma_bshipping_postcode").value;
      var cma_cma_adm1_long = document.getElementById("cma_adm1_long").value;
      var cma_cma_adm2_long = document.getElementById("cma_adm2_long").value;
      var cma_cma_adm1_short = document.getElementById("cma_adm1_short").value;
      var cma_cma_adm2_short = document.getElementById("cma_adm2_short").value;
      var cma_city = document.getElementById("cma_bshipping_city").value;
      var cma_address_1 = document.getElementById("cma_bshipping_address_1").value;
      var cma_address_full = results[0].formatted_address;
      var save_address = jQuery('#cma_saveaddress_checkbox').prop("checked") ? 1 : 0;
      var current_cart = jQuery('#cma-wrapper').hasClass("cma-current-cart") ? 1 : 0;
      var zone_id = jQuery('#cma-wrapper').hasClass("cma_zone_id") ? jQuery('#cma-wrapper').data('zone_id') : null;
      var data = {
        'action': 'cma_validate_shipping_location',
        'save_address': save_address,
        'country': cma_country,
        'postcode': cma_postcode,
        'cma_adm1_long': cma_cma_adm1_long,
        'cma_adm2_long': cma_cma_adm2_long,
        'cma_adm1_short': cma_cma_adm1_short,
        'cma_adm2_short': cma_cma_adm2_short,
        'city': cma_city,
        'address_1': cma_address_1,
        'full_address': cma_address_full,
        'current_cart': current_cart,
        'nonce_ajax': cmadel.nonce
      };

      if (zone_id != null) {
        data.zone_id = zone_id;
      }

      $.post(cmadel.ajax_url, data, function (response) {
        var validation_type = 'address';
        var evalu = evaluate_shipping_methods(response, latitude, longitude, validation_type, mode, is_from_map);
        $.when(evalu).then(function (evalue) {
          outcome.resolve(evalue);

          if (cmadel.is_checkout == 1 && evalue && $('#cma_saveaddress_checkbox').prop("checked")) {
            update_checkout_shipping_form(latlng);
          }
        });
      }).always(function () {
        if ($.fn.blockUI != 'undefined') {
          theblock.removeClass('processing').unblock();
        }
      });
    });
    return outcome.promise();
  }

  function getCountry(addrComponents) {
    for (var i = 0; i < addrComponents.length; i++) {
      if (addrComponents[i].types[0] == "country") {
        return addrComponents[i].short_name;
      }
    }

    return false;
  }
});