<?php
/**
 * Define the internationalization functionality
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @link       https://powerfulwp.com/
 * @since      1.0.0
 *
 * @package    Distance_Rate_Shipping_For_Woocommerce_Powerfulwp
 * @subpackage Distance_Rate_Shipping_For_Woocommerce_Powerfulwp/includes
 */
if ( ! class_exists( 'Distance_Rate_Shipping_For_Woocommerce_Powerfulwp_i18n' ) ) {
	/**
	 * Define the internationalization functionality.
	 *
	 * Loads and defines the internationalization files for this plugin
	 * so that it is ready for translation.
	 *
	 * @since      1.0.0
	 * @package    Distance_Rate_Shipping_For_Woocommerce_Powerfulwp
	 * @subpackage Distance_Rate_Shipping_For_Woocommerce_Powerfulwp/includes
	 * @author     PowerfulWP <apowerfulwp@gmail.com>
	 */
	class Distance_Rate_Shipping_For_Woocommerce_Powerfulwp_i18n {


		/**
		 * Load the plugin text domain for translation.
		 *
		 * @since    1.0.0
		 */
		public function load_plugin_textdomain() {

			load_plugin_textdomain(
				'distance-rate-shipping-for-woocommerce-powerfulwp',
				false,
				dirname( dirname( plugin_basename( __FILE__ ) ) ) . '/languages/'
			);

		}

	}

}
